/**
 * DevExtreme (integration/jquery/deferred.js)
 * Version: 17.2.0 (build 17262)
 * Build date: Tue Sep 19 2017
 *
 * Copyright (c) 2012 - 2017 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
var jQuery = require("jquery");
var Deferred = jQuery.Deferred;
var deferredUtils = require("../../core/utils/deferred");
var useJQueryRenderer = require("../../core/config")().useJQueryRenderer;
var compareVersion = require("../../core/utils/version").compare;
if (useJQueryRenderer) {
    var strategy = {
        Deferred: Deferred
    };
    strategy.when = compareVersion(jQuery.fn.jquery, [3]) < 0 ? jQuery.when : function(singleArg) {
        if (0 === arguments.length) {
            return (new Deferred).resolve()
        } else {
            if (1 === arguments.length) {
                return singleArg && singleArg.then ? singleArg : (new Deferred).resolve(singleArg)
            } else {
                return jQuery.when.apply(jQuery, arguments)
            }
        }
    };
    deferredUtils.setStrategy(strategy)
}
